	SUBROUTINE SEPIMAT(IQPNT)
**********************************************************
*  Written by S.Yu.Savrasov in Max-Planck-Institute, FRG.*
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
	COMPLEX*16 EPMAT(3,NPAT,3,NPAT,4),EPIMAT(-1:1,NPAT,-1:1,NPAT,4)
     &   ,TR(-1:1,3),VELMAT(-1:1,NPAT,-1:1,NPAT,4)
     &   ,TRMAT(3,NPAT,3,NPAT,4)
	DIMENSION AMASS(NSORTMAX),EARR(LIMZN,KMAX,NPANMAX),QPNT(3)
     &   ,WEIGH(LIMZN,KMAX,NPANMAX),WEIGD(LIMZN,KMAX,NPANMAX)
     &   ,VEL(3)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/ LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSW,NATOM       !!! from init
	COMMON /QMESH/   NQPNT,QPNT                          !!! from init
	COMMON /ENERGY/  EARR,WEIGH,WEIGD                    !!! from bands
	COMMON /EFERMI/  EF,DOS,VEL                          !!! from deltet
	COMMON /MESH/    NPNT                                !!! from ttrmsh
	COMMON /MASS/    AMASS                               !!! from init
	COMMON /EPIMAT/  EPIMAT,VELMAT                       !!! from delbnd
	COMMON /NBANDS/  NBNDF,NBNDE,NBNDT                   !!! from bands
	COMMON /TXTEL/   TXTEL                               !!! from init
	COMMON /UNIT/    IUN                                 !!! from init
	DATA TR/(+0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,(-0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 1.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)/
C  FIND DENSITY OF STATES AT THE FERMI LEVEL
	DOT=0.D0
	DO 20 IBND=1,NBNDT(1)
	DO 10 IPNT=1,NPNT
	DOT=DOT+WEIGD(IBND,IPNT,1)
   10   CONTINUE
   20   CONTINUE
	IF(ABS(DOS-DOT).GE.1.D-08)PRINT*,'ERROR IN <EPIMAT> :',DOS,DOT 
	IF(DOS.EQ.0.D0)PRINT*,'ERROR IN <EPIMAT> : DOS.EQ.0'
	IF(DOS.EQ.0.D0)DOS=1.D0
	AVL=VEL(1)+VEL(2)+VEL(3)
	IF(AVL.EQ.0.D0)PRINT*,'ERROR IN <EPIMAT> : AVL.EQ.0'
	IF(AVL.EQ.0.D0)AVL=1.D0
	dos=31.6868d0
	avl=2.372d0
C  MAKE TOTAL HOPFIELD MATRIX IN CARTESIAN SYSTEM
	WRITE(IUN,1010)
	WRITE(IUN,1015)(QPNT(I),I=1,3)
	DO 220 INUC1=1,NATOM               !!! over nuclear shifts
	DO 210 INUC=1,NATOM                !!! over nuclear shifts
	WRITE(IUN,1020)INUC1,TXTEL(IS(INUC1)),INUC,TXTEL(IS(INUC))
	DO 60 I=1,3                        !!! over x,y,z
	DO 50 J=1,3                        !!! over x,y,z
	EPMAT(I,INUC1,J,INUC,1)=(0.0,0.0)
	EPMAT(I,INUC1,J,INUC,2)=(0.0,0.0)
	EPMAT(I,INUC1,J,INUC,3)=(0.0,0.0)
	EPMAT(I,INUC1,J,INUC,4)=(0.0,0.0)
	TRMAT(I,INUC1,J,INUC,1)=(0.0,0.0)
	TRMAT(I,INUC1,J,INUC,2)=(0.0,0.0)
	TRMAT(I,INUC1,J,INUC,3)=(0.0,0.0)
	TRMAT(I,INUC1,J,INUC,4)=(0.0,0.0)
	DO 40 MY1=-1,1                     !!! over -1,0,1
	DO 30 MY=-1,1                      !!! over -1,0,1
	EPMAT(I,INUC1,J,INUC,1)=EPMAT(I,INUC1,J,INUC,1)+
     &  EPIMAT(MY1,INUC1,MY,INUC,1)*TR(MY1,I)*TR(MY,J)/DOS
	EPMAT(I,INUC1,J,INUC,2)=EPMAT(I,INUC1,J,INUC,2)+
     &  EPIMAT(MY1,INUC1,MY,INUC,2)*TR(MY1,I)*TR(MY,J)/DOS
	EPMAT(I,INUC1,J,INUC,3)=EPMAT(I,INUC1,J,INUC,3)+
     &  EPIMAT(MY1,INUC1,MY,INUC,3)*TR(MY1,I)*TR(MY,J)/DOS
	EPMAT(I,INUC1,J,INUC,4)=EPMAT(I,INUC1,J,INUC,4)+
     &  EPIMAT(MY1,INUC1,MY,INUC,4)*TR(MY1,I)*TR(MY,J)/DOS
	TRMAT(I,INUC1,J,INUC,1)=TRMAT(I,INUC1,J,INUC,1)+
     &  VELMAT(MY1,INUC1,MY,INUC,1)*TR(MY1,I)*TR(MY,J)/AVL/2.D0
	TRMAT(I,INUC1,J,INUC,2)=TRMAT(I,INUC1,J,INUC,2)+
     &  VELMAT(MY1,INUC1,MY,INUC,2)*TR(MY1,I)*TR(MY,J)/AVL/2.D0
	TRMAT(I,INUC1,J,INUC,3)=TRMAT(I,INUC1,J,INUC,3)+
     &  VELMAT(MY1,INUC1,MY,INUC,3)*TR(MY1,I)*TR(MY,J)/AVL/2.D0
	TRMAT(I,INUC1,J,INUC,4)=TRMAT(I,INUC1,J,INUC,4)+
     &  VELMAT(MY1,INUC1,MY,INUC,4)*TR(MY1,I)*TR(MY,J)/AVL/2.D0
  30    CONTINUE                           !!! over -1,0,1
  40    CONTINUE                           !!! over -1,0,1
	TRMAT(I,INUC1,J,INUC,4)=TRMAT(I,INUC1,J,INUC,1)+
     &  TRMAT(I,INUC1,J,INUC,2)-TRMAT(I,INUC1,J,INUC,3)*2.D0
  50    CONTINUE                           !!! over x,y,z
  60    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1080)
	DO 110 I=1,3                       !!! over x,y,z
	WRITE(IUN,1030)(EPMAT(I,INUC1,J,INUC,1),J=1,3)
 110    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1090)
	DO 120 I=1,3                       !!! over x,y,z
	WRITE(IUN,1030)(EPMAT(I,INUC1,J,INUC,2),J=1,3)
 120    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1100)
	DO 130 I=1,3                       !!! over x,y,z
	WRITE(IUN,1030)(EPMAT(I,INUC1,J,INUC,3),J=1,3)
 130    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1110)
	DO 140 I=1,3                       !!! over x,y,z
	WRITE(IUN,1030)(EPMAT(I,INUC1,J,INUC,4),J=1,3)
 140    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1120)
	DO 150 I=1,3                       !!! over x,y,z
	WRITE(IUN,1030)(TRMAT(I,INUC1,J,INUC,1),J=1,3)
 150    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1130)
	DO 160 I=1,3                       !!! over x,y,z
	WRITE(IUN,1030)(TRMAT(I,INUC1,J,INUC,2),J=1,3)
 160    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1140)
	DO 170 I=1,3                       !!! over x,y,z
	WRITE(IUN,1030)(TRMAT(I,INUC1,J,INUC,3),J=1,3)
 170    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1150)
	DO 180 I=1,3                       !!! over x,y,z
	WRITE(IUN,1030)(TRMAT(I,INUC1,J,INUC,4),J=1,3)
 180    CONTINUE                           !!! over x,y,z
 210    CONTINUE                           !!! over nuclear shifts
 220    CONTINUE                           !!! over nuclear shifts
1010  FORMAT(1X,'**** ELECTRON - PHONON INTERACTION (Ry/a.u**2) ****') 
1015  FORMAT(1X,'Q-vector: (',G11.4,',',G11.4,',',G11.4,')')
1020  FORMAT(1X,'Elements: atom #',I2,1X,A10,' and #',I2,1X,A10)
1030  FORMAT(1X,2G11.4,'|',2G11.4,'|',2G11.4)
1080  FORMAT(1X,'Hopfield matrix (rigid part) is given by ---->')
1090  FORMAT(1X,'the same, for k-point-convergency check  ---->')
1100  FORMAT(1X,'Hopfield matrix (total part) is given by ---->')
1110  FORMAT(1X,'the same, for k-point-convergency check  ---->')
1120  FORMAT(1X,'Tranport <v(k  j )*v(k  j )> is given by ---->')
1130  FORMAT(1X,'Tranport <v(k+qj")*v(k+qj")> is given by ---->')
1140  FORMAT(1X,'Tranport <v(k  j )*v(k+qj")> is given by ---->')
1150  FORMAT(1X,'Tranport (v(kj)-v(k+qj"))^2  is given by ---->')
	END
