	SUBROUTINE SEPISYM(IQPNT)
***********************************************************
*  Written by S.Yu.Savrasov in Max-Planck-Institute, FRG. *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX),IS(NPAT)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,IKOV(NOPRMAX),IP(NPAT,NOPRMAX),ISG(NOPRMAX,NOPRMAX)
	COMPLEX*16 U(NWIGMAX,48),PHSQ
     &   ,EPIMAT(-1:1,NPAT,-1:1,NPAT,4)
     &   ,VELMAT(-1:1,NPAT,-1:1,NPAT,4)
     &   ,TMPMAT(-1:1,NPAT,-1:1,NPAT,4)
     &   ,TMVMAT(-1:1,NPAT,-1:1,NPAT,4)
	DIMENSION  QPNT(3),RDC(3,NPAT,NOPRMAX)
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSW,NATOM          !!! from init
	COMMON /QMESH/  NQPNT,QPNT                             !!! from init
	COMMON /INVERS/ INV,IKOV                               !!! from group
	COMMON /GROUPOUT/NGROUP,U,IP,RDC                       !!! from group
	COMMON /SUBGROUP/NSGQ,NGEQ,ISG                         !!! from symmsh
	COMMON /EPIMAT/ EPIMAT,VELMAT                          !!! from d2band
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	DATA PI/3.141592653589793D0/
	DO 50 INUC1=1,NATOM
	DO 40 INUC=1,NATOM
	DO 30 MY1=-1,1
	DO 20 MY =-1,1
	DO 10 II=1,4
	TMPMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
	TMVMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
  10    CONTINUE
  20    CONTINUE
  30    CONTINUE
  40    CONTINUE
  50    CONTINUE
C  DO OVER SYMMETRY GROUP FOR Q-VECTOR
	DO 180 INUC1=1,NATOM                  !!! over displacements
	DO 170 INUC=1,NATOM                   !!! over displacements 
	DO 160 MY1=-1,1                       !!! over polarizations
	DO 150 MY =-1,1                       !!! over polarizations
	DO 140 IGEQ=1,NGEQ                    !!! over group of q-vector
	IR=ISG(IGEQ,1)                        !!! element "g" in the main G-list
	IG=IKOV(IR)                           !!! element "g" after Kovalev
	INUC1G=IP(INUC1,IR)
	INUCG =IP(INUC ,IR)
	SQ=QPNT(1)*(RDC(1,INUC1,IR)-RDC(1,INUC,IR))+
     &     QPNT(2)*(RDC(2,INUC1,IR)-RDC(2,INUC,IR))+
     &     QPNT(3)*(RDC(3,INUC1,IR)-RDC(3,INUC,IR))
	PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
	DO 130 M1=-1,1                        !!! over polarizations
	DO 120 M =-1,1                        !!! over polarizations
	IWIGM1=3+3*(1+M1)+MY1
	IWIGM =3+3*(1+M) +MY
	DO 110 II=1,4
C  ROTATE BAND CONTRIBUTION
	TMPMAT(MY1,INUC1,MY,INUC,II)=TMPMAT(MY1,INUC1,MY,INUC,II)+
     &  CONJG(U(IWIGM1,IG))*EPIMAT(M1,INUC1G,M,INUCG,II)*
     &  CONJG(U(IWIGM,IG))*PHSQ
	TMVMAT(MY1,INUC1,MY,INUC,II)=TMVMAT(MY1,INUC1,MY,INUC,II)+
     &  CONJG(U(IWIGM1,IG))*VELMAT(M1,INUC1G,M,INUCG,II)*
     &  CONJG(U(IWIGM,IG))*PHSQ
 110	CONTINUE
 120    CONTINUE                             !!! over m
 130    CONTINUE                             !!! over m1
 140    CONTINUE                             !!! over group of q-vector
 150    CONTINUE                             !!! over polarizations
 160    CONTINUE                             !!! over polarizations
 170    CONTINUE                             !!! over displacements
 180    CONTINUE                             !!! over displacements
C  NORMALIZATION
	DO 250 INUC1=1,NATOM
	DO 240 INUC=1,NATOM
	DO 230 MY1=-1,1
	DO 220 MY =-1,1
	DO 210 II=1,4
	EPIMAT(MY1,INUC1,MY,INUC,II)=TMPMAT(MY1,INUC1,MY,INUC,II)
     &  /DBLE(NGEQ)
	VELMAT(MY1,INUC1,MY,INUC,II)=TMVMAT(MY1,INUC1,MY,INUC,II)
     &  /DBLE(NGEQ)
 210    CONTINUE
 220    CONTINUE
 230    CONTINUE
 240    CONTINUE
 250    CONTINUE
	END
