	SUBROUTINE QVECTOR
************************************************************
*  Sets perturbation vector and mixing values.             *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NITER(-1:1,NPAT),KEY(-1:1,NPAT),KSP(-1:1,NPAT)
     &   ,NQDIV(3),NDIV(3),LBROY(-1:1,NPAT),IBROY(-1:1,NPAT)
     &   ,NRAD0(NSORTMAX),ILSV0(NSORTMAX)
	DIMENSION EPS(-1:1,NPAT),TAU(3,NPAT),ORTH(2:3)
     &   ,A(3,3),G(3,3),QPNT(3),QPNT0(3),AK(3,3),RK(3,3)
     &   ,ADMIX1(-1:1,NPAT),ADMIN (-1:1,NPAT),ADMAX(-1:1,NPAT)
     &   ,ADMSPN(-1:1,NPAT),ASMIN (-1:1,NPAT),ASMAX(-1:1,NPAT)
     &   ,ADMIXB(-1:1,NPAT),ADMIXH(-1:1,NPAT)
        CHARACTER*60 SCNFILE(-1:1,NPAT,100),DROFILE(-1:1,NPAT)
     &   ,DPSFILE(-1:1,NPAT),DSVFILE(-1:1,NPAT),DPVFILE(-1:1,NPAT)
     &   ,DSFFILE,PHNFILE,TMPFILE,OUTFILE,WGTFILE,HUBFILE,DFILE
     &   ,SCFFILE,STRFILE,PNTFILE,SCRFILE(100),TXTSCR
        CHARACTER*60 PLZFILE(NENVMAX),PLSFILE(NENVMAX)
     &   ,SCPFILE(NENVMAX,100)
	CHARACTER TEXQ*10,TXTEL(NSORTMAX)*10,TXTSP(2)*2,UN(100)*2
     &   ,TEXM*60,TASK*10,RS*10,TNUC(-1:1,NPAT)*10,TPTB(NENVMAX)*10
	LOGICAL EXIST,LNUC(-1:1,NPAT)
C Controls:
        COMMON /CONTROL/ LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /SPIN/    NSPIN                               !!! from init
	COMMON /PLZCOM/  NPLZ,LPLZ,IPLZ                      !!! from init
C Inputs:
	COMMON /LATTICE/ A,G,AK,RK                           !!! from init
	COMMON /BASIS/   TAU                                 !!! from init
	COMMON /QMESH/   NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from init
        COMMON /PHNCOM/  ITERMAX,NITER,EPS                   !!! from init
        COMMON /INTTR/   NDIV                                !!! from init
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                     !!! from init
C Mixings:
        COMMON /MIXDRHO/ ADMIX1,ADMIN,ADMAX,KEY              !!! from init
        COMMON /MIXDMAG/ ADMSPN,ASMIN,ASMAX,KSP              !!! from init
        COMMON /MIXBROY/ LBROY,IBROY,ADMIXB,ADMIXH           !!! from init
C Outputs:
        COMMON /OUT0EL/  SCRFILE,SCFFILE,STRFILE,PNTFILE,HUBFILE,OUTFILE
        COMMON /OUT1EL/  ICON,ISRF,IKOV,IBND,IPSI,IHBR,IOUT  !!! from init
        COMMON /OUT0PH/  SCNFILE,DROFILE,DSVFILE,DPSFILE,DPVFILE!from init
        COMMON /OUT1PH/  IDSF,IDRO,IPHN,ITMP,IDSV,IWTH       !!! from init
        COMMON /OUT2PH/  DSFFILE,PHNFILE,TMPFILE,WGTFILE     !!! from init
        COMMON /OUT4PH/  SCPFILE,PLZFILE,PLSFILE             !!! from init
	COMMON /SCRDIR/  TXTSCR                              !!! from block
        COMMON /TXTEL/   TXTEL,TXTSP,TEXQ,TEXM,TASK          !!! from init
	COMMON /UNIT/    IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
C DEFAULT FILE SETTINGS
C Phonon spectrum
	IPHN=1
	PHNFILE='phn.dat' 
C OUTPUT FILE
        IUN=6
        END
