	SUBROUTINE READINI           
************************************************************
*  <READINI> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),NHSORT(NSORTMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,ICOR(NSORTMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NKAP(NPANMAX),NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDC(NPANMAX)
     &   ,NSEM(NSORTMAX),LBS(36,NSORTMAX),NDS(36,NSORTMAX)
     &   ,MNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),LR(NSORTMAX)
     &   ,ITS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),NDIV(3),NDIC(3)
     &   ,NCLS(0:LMAXT,NSORTMAX,NPANMAX),NBNDT(NPANMAX),ISPL(NSORTMAX)
     &   ,LNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),NFFTG(3)
     &   ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DHLOG(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,SPLIT(NSORTMAX),ORTH(2:3),SASA(NSORTMAX),SH(3,NPANMAX)
     &   ,Z(NSORTMAX),ZCORE(NSORTMAX),SMT(NSORTMAX),STRAIN(3,3,2)
     &   ,RLOC(NSORTMAX),SROU(NSORTMAX),AMASS(NSORTMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,ESEM(36,NSORTMAX)
	CHARACTER*60 INIFILE,SC0FILE,STRFILE,SCRFILE(100)
     &   ,HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
     &   ,CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &   ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &   ,OUTFILE
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),CASE 
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),EXIST
	CHARACTER TEXT*64,TXT*72,TXTEL(NSORTMAX)*10,TXTSP(2)*2
C Controls:
	COMMON /CONTROL/ LIFT,LMTO,NCOU,NOVR,NPFR            !!! from readini
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from readini
	COMMON /SCF1COM/ ITERMAX                             !!! from readini
	COMMON /ORBS/    NORBS                               !!! from readini
	COMMON /SPIN/    NSPIN,SPLIT,ISPL                    !!! from readini
        COMMON /RWFCOM/  NRWF,LRWF,IRWF                      !!! from readini
	COMMON /RELATIV/ LR                                  !!! from readini
	COMMON /COR1/    ICOR                                !!! from readini
	COMMON /EXCH/    IEXCH                               !!! from readini
C Inputs:
	COMMON /LATPAR/  PAR,ORTH,OMEGAC,STRAIN,VV0          !!! from readini
	COMMON /KAPPAR/  NPAN,NKAP,EK,EKAP                   !!! from readini
	COMMON /PANPAR/  LTPAN,LSPAN,IATS,ISTS               !!! from readini
	COMMON /POTCOM/  SWZ,SMT                             !!! from readini
        COMMON /MASS/    AMASS                               !!! from readini
	COMMON /NBANDS/  NBNDF,NBNDE,NBNDT,NBNDC,POLUS       !!! from readini
	COMMON /MULTRO/  Z,ZCORE                             !!! from readini
	COMMON /ASASPH/  SASA                                !!! from readini
        COMMON /SCRINP/  RLOC                                !!! from readini
        COMMON /INTMESH/ NSHE,NPOL,SROU                      !!! from readini
C Mixings:
	COMMON /MIXRHO1/ ADMIX1,ADMIN,ADMAX,KEY              !!! from readini
	COMMON /MIXMAG1/ ADSPIN,ASMIN,ASMAX,KSP              !!! from readini
	COMMON /MIXBROY/ LBROY,IBROY,ADMIXB,ADMIXH           !!! from readini
	COMMON /ACCU/    EPSTOT,EPSRHO,EPSMAG                !!! from readini
C K-mesh:
	COMMON /INTTR/   NDIV,NDIC,SH                        !!! from readini
C Pot.pars:
	COMMON /INPPAR/  TNY,ENY,DNY,NODES,MNY,DHLOG,NCLS,LNY!!! from readini
C Plane waves:
        COMMON /FFTMESH/ NFFTG                               !!! from readini
        COMMON /TEILORG/ KEYT,BZM                            !!! from readini
        COMMON /ACCURG/  EPSR,EPSG,ECUTG                     !!! from readini
C Additional inputs:
	COMMON /INP0/    INIFILE,SC0FILE,STRFILE             !!! from init
        COMMON /INP1/    ICHUB,ICHOP,ICOPT,ICENR,ICPNT       !!! from readini
        COMMON /INP2/    HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE                  
C Outputs:
	COMMON /OUT0/    SCRFILE                             !!! from readini
	COMMON /OUT1/    ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND !!! from readini
     &                  ,ICPOT,ICFAT,ICDOS,ICSCF,ICOUT
	COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &                  ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &                  ,OUTFILE
	COMMON /TEXT/    TEXT                                !!! from readini
	COMMON /TXTEL/   TXTEL,TXTSP                         !!! from readini
	COMMON /UNIT/    IUN                                 !!! from readini
	DATA PI/3.141592653589793D0/                             
C--------------------------------------------
C****** READ INIFILE ************
C--------------------------------------------
	OPEN(1,FILE=INIFILE,STATUS='OLD')
	READ(1,1000) TEXT
C    LIFT=1 - strmsh ; =2 + bands ; =3 + self-consistence
C    LMTO=1 - original (bare) LMTO
C    NCOU=0 - without =1 - with Coulomb corrections
C    LRWF=0 - froze Phi, 1/2 - adjust Phi.
C    NPFR=0 - without =1 with atomic force calculations
	READ(1,1001)TXT
	READ(1,*)LIFT
	READ(1,*)LMTO
	READ(1,*)NCOU
	READ(1,*)LRWF
	READ(1,*)NPFR
C   ****** EXCHANGE-CORRELATION CODE ******
C    IEXCH=1 Barth-Hedin,2:Gun-Lun,3:Mor-Jan-Will,4:Vosko-Wilk,Nuss.
C          5:Perdew-Wang 1991, 6:Gaspar-Kohn-Sham 
C    for IEXCH < 0 generalized gradient corrections after Perdew 1991
C    are included. The local potential is according to ABS(IEXCH)
	READ(1,1000)TXT
	READ(1,*)IEXCH
	IF(IEXCH.LT.0)CALL ERRMSG('READINI',11,' ','W')
C   ****** ITERATIVE PROCEDURES LIMITS : ******
C   ITERMAX- Max.number of iterations 
C   ADMIX1 - Charge Density Admixture
C   ADSPIN - Magnetization  Admixture
C   EPSTOT - Total energy accuracy (Ry)
C   LBROY  - switch on Broyden mixing for Lbroy=0,1,... components
C   IBROY  - switch on Broyden mixing after N=IBROY iterations
C   ADMIXB - Initial Broyden Jakobian
C   ADMIXH - Mixing for high-l components of the density if
C            low-l components (.le lbroy) are mixed with Broyden
	READ(1,1000)TXT
	READ(1,*) ITERMAX,ADMIX1,ADSPIN,EPSTOT
     &           ,LBROY,IBROY,ADMIXB,ADMIXH
C   SETTINGS FOR LINEAR MIXING
	ADMIN=MAX(0.D0,ADMIX1/2.D0)
	ADMAX=MIN(1.D0,ADMIX1*2.D0)
	ASMIN=ADSPIN
	ASMAX=ADSPIN
C   KEY=0(1) - Admixture=ADMIX1(Admixture=1.D0) when iter=1
	KEY=0
	KSP=0
C   ********* ATOMIC DATA : *********
C   NATOM - number of atoms in unit-cell
C   NSORT - number of different types of atoms
C   NSPIN - number of spins
C   NORBS - 1/2 which switches off/on spin-orbit coupling
C   PAR   - lattice parameter, equillibrium volume ratio
C   IS(IATOM) - number of sort for each atom
C   NKAP,EKAP  - number of tail for wave functions and their energies
	READ(1,1000) TXT
	READ(1,*)NATOM,NSORT,NSPIN,NORBS
C   CHECK THEM
	IF(NATOM.GT.NPAT)STOP'<READINI>: # OF ATOMS MISMATCHES,
     &  INCREASE "NPAT" IN PARAM.DAT'
	IF(NSORT.GT.NSORTMAX)STOP'<READINI>: # OF SORTS MISMATCHES,
     &  INCREASE "NSORTMAX" IN PARAM.DAT'
	IF(NSPIN.GT.NSPINMAX)STOP'<READINI>: # OF SPINS MISMATCHES,
     &  SET "NSPINMAX=2" IN PARAM.DAT'
	IF(NORBS.GT.NSPINMAX)STOP'<READINI>: TO SWITCH ON SO-COUPLING,
     &  SET "NSPINMAX=2" IN PARAM.DAT'
	IF(NSPIN.EQ.1.AND.NORBS.EQ.2)STOP'<READINI>: TO SWITCH SO-COUPLING,
     &  NSPIN MUST BE EQUAL 2'
	READ(1,*)  PAR0,VV0
	READ(1,*) (IS(I),I=1,NATOM)
	READ(1,*)  NKAP(1),(EKAP(IKAP,1),IKAP=1,NKAP(1))
	IF(NKAP(1).GT.NKAPMAX)STOP'<READINI>: # OF KAPPAS MISMATCHES'
C   ILST(ISORT) - lmax for trial function expansion
C   ILSB(ISORT) - lmax for basis set
C   ILSV(ISORT) - lmax for the potential and charge density
C   Z(ISORT) - nuclear charge
C   ZCORE(ISORT) - number of core electrons
C   LR(ISORT) =0 - non =1 - semirelativistic version
C   ICOR(ISORT) - core renormalisation key
C   ISPL(ISORT) = 1 - permanent splitting (magnetic field)
C   SPLIT(ISORT) - splitting in case spin-polarisation 
C   AMASS(ISORT) - nuclear mass of the element
C   SMT(ISORT)   - mt-sphere radius
C   ITS(IKAP,L,ISORT) - basis set description: 1 - present, 0 - absent in basis
C   MNY(IKAP,L,ISORT) - choice of Eny: 0-input Eny, 1-input Dny, 2-semicore,
C   ENY(IKAP,L,ISORT) - initial Eny                 3 - centers of gravity
C   DNY(IKAP,L,ISORT) - initial Dny
C   NODES(IKAP,L,ISORT) - main quantum numbers
	DO ISORT=1,NSORT               !!! over diff.types of atoms
	READ(1,1000)TXTEL(ISORT)
	READ(1,*)Z(ISORT),ZCORE(ISORT),LR(ISORT),ICOR(ISORT),
     &  ISPL(ISORT),SPLIT(ISORT),AMASS(ISORT)
        READ(1,*)SMT(ISORT),SROU(ISORT),SASA(ISORT),RLOC(ISORT)
	READ(1,*)ILST(ISORT),ILSB(ISORT),ILSV(ISORT)
	IF(ILST(ISORT).GT.LMAXT)STOP'<READINI>: LMAXT MISMATCH,
     &  INCREASE "LMAXT" IN PARAM.DAT'
	IF(ILSB(ISORT).GT.LMAXB)STOP'<READINI>: LMAXB MISMATCH,
     &  INCREASE "LMAXB" IN PARAM.DAT'
	IF(ILSV(ISORT).GT.LMAXV)STOP'<READINI>: LMAXV MISMATCH,
     &  INCREASE "LMAXV" IN PARAM.DAT'
	IF(ILST(ISORT).GT.ILSV(ISORT))STOP'<READINI>:ILST.GT.ILSV'
	IF(LMAXT.GT.LMAXV)STOP'<READINI>:LMAXT.GT.LMAXV,
     &  SET "LMAXT.LE.LMAXV" IN PARAM.DAT'
	READ(1,1000)TXT
	DO IKAP=1,NKAP(1)
	READ(1,1000)TXT
	READ(1,*)(NODES(L,ISORT,IKAP,1),L=0,ILSB(ISORT))
	READ(1,*)(ITS  (L,ISORT,IKAP,1),L=0,ILSB(ISORT))
	READ(1,*)(MNY  (L,ISORT,IKAP,1),L=0,ILSB(ISORT))
	READ(1,*)(ENY  (L,ISORT,IKAP,1,1),L=0,ILSB(ISORT)),ENYUP
	READ(1,*)(DNY  (L,ISORT,IKAP,1,1),L=0,ILSB(ISORT))
	DO L=0,ILSB(ISORT)
	NODES(L,ISORT,IKAP,1)=NODES(L,ISORT,IKAP,1)-L-1
	ENY(L,ISORT,IKAP,1,NSPIN)=ENY(L,ISORT,IKAP,1,1)
	DNY(L,ISORT,IKAP,1,NSPIN)=DNY(L,ISORT,IKAP,1,1)
	ENDDO
	DO L=ILSB(ISORT)+1,ILST(ISORT)
	ENY(L,ISORT,IKAP,1,1)=ENYUP
	ENY(L,ISORT,IKAP,1,NSPIN)=ENYUP
	ENDDO
	ENDDO
	READ(1,1000)TXT
	READ(1,*)NSEM(ISORT)
	DO ISEM=1,NSEM(ISORT)
	READ(1,*)NDS(ISEM,ISORT),LBS(ISEM,ISORT),ESEM(ISEM,ISORT)
	NDS(ISEM,ISORT)=NDS(ISEM,ISORT)-LBS(ISEM,ISORT)-1
        ENDDO                             !!! over diff.types of atoms
        ENDDO   
C   ****** CONTROL PARAMETERS FOR OUTPUT AND RESTART ******
	READ(1,1000)TXT
	READ(1,*)ICCON,CONFILE      !!! structure constants
	READ(1,*)ICFTR,FTRFILE      !!! fourier constants file
	READ(1,*)ICPSI,PSIFILE      !!! wave functions
	READ(1,*)ICSCR,SCRFILE(1)   !!! temporary storage
	READ(1,*)ICBND,BNDFILE      !!! band structure
	READ(1,*)ICPOT,POTFILE      !!! full potential
	READ(1,*)ICFAT,FATFILE      !!! fat bands
	READ(1,*)ICDOS,DOSFILE      !!! density of states
	READ(1,*)ICSCF,SCFFILE      !!! charge density destribution
	READ(1,*)ICOUT,OUTFILE      !!! current output
C   ***** OTHER DATA FOR NMT-PACK *****
C   NTF - number of filled bands
C   NFF - number of fully filled bands
C   NEF - number of bands at EF
C   NDIV(1..3) - divisions along G1,G2,G3 of the BZ
C   NDC - divisions along G1 for semicore panels
	READ(1,1000) TXT
	READ(1,*)NFF,NEF,POLUS
	READ(1,*)(NDIV(I),I=1,3),NDC
        READ(1,*)(NFFTG(I),I=1,3),EPSR,EPSG,KEYT,BZM
        IF(NFFTG(1).EQ.0)STOP'SET FFT-GRID IN INIFILE'
        IF(MOD(NFFTG(1),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
        IF(MOD(NFFTG(2),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
        IF(MOD(NFFTG(3),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
        IF(NDC.EQ.0)STOP'SET DIVISIONS FOR SEMICORE PANELS NC.NE.0'
C   ***** ADDITIONAL INPUT FILES IF NECESSARY *****
        READ(1,*,END=999,ERR=999)
        READ(1,*,END=999,ERR=999)ICHUB,HUBFILE  !!! Hubbard corrections for LDA+U
        READ(1,*,END=999,ERR=999)ICHOP,HOPFILE  !!! Hopping integrals for TB
        READ(1,*,END=999,ERR=999)ICOPT,OPTFILE  !!! Optical properties
        READ(1,*,END=999,ERR=999)ICENR,ENRFILE  !!! Energy bands for weights
        READ(1,*,END=999,ERR=999)ICPNT,PNTFILE  !!! List of q-points
 999    CLOSE(1)
C  SET DIVISIONS FOR SEMICORE PANELS OR FOR INTEGRATION WEIGHTS
	DN2=DBLE(NDIV(2))/DBLE(NDIV(1))
	DN3=DBLE(NDIV(3))/DBLE(NDIV(1))
	NDIC(1)=NDC
	NDIC(2)=ANINT(DBLE(NDC)*DN2)
	NDIC(3)=ANINT(DBLE(NDC)*DN3)
	IF(NDIC(2).EQ.0)NDIC(2)=1
	IF(NDIC(3).EQ.0)NDIC(3)=1
C  SET LATTICE PARAMETERS ACCORDING TO V/V0
	PAR=PAR0*VV0**0.333333333333333333D0
	DO ISORT=1,NSORT
	SMT(ISORT)=SMT(ISORT)*PAR/PAR0
	ENDDO
C  SET # OF ATOMS FOR GIVEN SORT ARRAY
	DO ISORT=1,NSORT
	NHSORT(ISORT)=0
	DO IATOM=1,NATOM
	IF(IS(IATOM).EQ.ISORT)NHSORT(ISORT)=NHSORT(ISORT)+1
	ENDDO
	ENDDO
C  DEFINE MAIN VALENCE PANEL
	NBND=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	I=0
	DO IKAP=1,NKAP(1)
	DO L=0,ILSB(ISORT)
	LTPAN(L,IATOM,IKAP,1)=.FALSE.
	LSPAN(L,ISORT,IKAP,1)=.FALSE.
	IF(ITS(L,ISORT,IKAP,1).EQ.1)THEN
	LTPAN(L,IATOM,IKAP,1)=.TRUE.
	LSPAN(L,ISORT,IKAP,1)=.TRUE.
	I=I+1
	NBND=NBND+2*L+1
	ENDIF
	ENDDO
	DO L=ILSB(ISORT)+1,LMAXT
	LTPAN(L,IATOM,IKAP,1)=.FALSE.
	LSPAN(L,ISORT,IKAP,1)=.FALSE.
	MNY(L,ISORT,IKAP,1)=0
	ENDDO
	LTPAN(LMAXT+1,IATOM,IKAP,1)=.FALSE.
	LSPAN(LMAXT+1,ISORT,IKAP,1)=.FALSE.
	ENDDO
	IATS(IATOM,1)=0
	ISTS(ISORT,1)=0
	IF(I.NE.0)IATS(IATOM,1)=IATOM
	IF(I.NE.0)ISTS(ISORT,1)=ISORT
	ENDDO
	NBNDT(1)=NBND
C  DEFINE # OF SEMICORE PANELS AND ATOMS PARTICIPATING IN EACH PANEL
	IPAN=1
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO ISEM=1,NSEM(ISORT)
	ILSB(ISORT)=MAX(ILSB(ISORT),LBS(ISEM,ISORT))
	I=0
	DO JPAN=2,IPAN
	IF(ESEM(ISEM,ISORT).NE.EKAP(1,JPAN))I=I+1
	ENDDO
	IF(I.EQ.IPAN-1)THEN
	IPAN=IPAN+1
	NKAP(IPAN)=1
	EKAP(1,IPAN)=ESEM(ISEM,ISORT)
	ENDIF
	ENDDO
	ENDDO
	NPAN=IPAN
	DO IPAN=2,NPAN
	NBND=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	IATS(IATOM,IPAN)=0
	ISTS(ISORT,IPAN)=0
	DO L=0,ILST(ISORT)
	LSPAN(L,ISORT,1,IPAN)=.FALSE.
	LTPAN(L,IATOM,1,IPAN)=.FALSE.
	MNY(L,ISORT,1,IPAN)=0
	ENDDO
	LTPAN(ILST(ISORT)+1,IATOM,1,IPAN)=.FALSE.
	LSPAN(ILST(ISORT)+1,ISORT,1,IPAN)=.FALSE.
	DO ISEM=1,NSEM(ISORT)
	IF(ESEM(ISEM,ISORT).EQ.EKAP(1,IPAN))THEN
	L=LBS(ISEM,ISORT)
	IATS(IATOM,IPAN)=IATOM
	ISTS(ISORT,IPAN)=ISORT
	NBND=NBND+2*L+1
	LTPAN(L,IATOM,1,IPAN)=.TRUE.
	LSPAN(L,ISORT,1,IPAN)=.TRUE.
	MNY(L,ISORT,1,IPAN)=2
	NODES(L,ISORT,1,IPAN)=NDS(ISEM,ISORT)
        ENY(L,ISORT,1,IPAN,1)=EKAP(1,IPAN)
        ENY(L,ISORT,1,IPAN,NSPIN)=EKAP(1,IPAN)
	ENDIF
	ENDDO
	ENDDO
	NBNDF(IPAN)=NBND
	NBNDT(IPAN)=NBND
	NBNDE(IPAN)=NBND+1
	NBNDC(IPAN)=0
	ENDDO
C SORT MULTIPLE KAPPA BASIS OVER DIFFERENT CLASSES
        DO IPAN=1,NPAN
        DO ISORT=1,NSORT
        DO L=0,ILST(ISORT)
        DO IKAP=1,NKAP(IPAN)
        LNY(L,ISORT,IKAP,IPAN)=0
        ENDDO
        ICLS=0
        DO IKAP=1,NKAP(IPAN)
        IF(LNY(L,ISORT,IKAP,IPAN).EQ.0)THEN
        ICLS=ICLS+1
        DO JKAP=1,NKAP(IPAN)
        CASE=MNY(L,ISORT,IKAP,IPAN).EQ.0.AND.
     &       MNY(L,ISORT,JKAP,IPAN).EQ.0.AND.
     &       ENY(L,ISORT,IKAP,IPAN,1).EQ.
     &       ENY(L,ISORT,JKAP,IPAN,1).AND.
     &       ENY(L,ISORT,IKAP,IPAN,NSPIN).EQ.
     &       ENY(L,ISORT,JKAP,IPAN,NSPIN)
        IF(.NOT.CASE)CASE=
     &       MNY(L,ISORT,IKAP,IPAN).EQ.1.AND.
     &       MNY(L,ISORT,JKAP,IPAN).EQ.1.AND.
     &       DNY(L,ISORT,IKAP,IPAN,1).EQ.
     &       DNY(L,ISORT,JKAP,IPAN,1).AND.
     &       DNY(L,ISORT,IKAP,IPAN,NSPIN).EQ.
     &       DNY(L,ISORT,JKAP,IPAN,NSPIN).AND.
     &       NODES(L,ISORT,IKAP,IPAN).EQ.
     &       NODES(L,ISORT,JKAP,IPAN)
        IF(.NOT.CASE)CASE=
     &       MNY(L,ISORT,IKAP,IPAN).EQ.2.AND.
     &       MNY(L,ISORT,JKAP,IPAN).EQ.2.AND.
     &       NODES(L,ISORT,IKAP,IPAN).EQ.
     &       NODES(L,ISORT,JKAP,IPAN)
        IF(.NOT.CASE)CASE=
     &       MNY(L,ISORT,IKAP,IPAN).EQ.3.AND.
     &       MNY(L,ISORT,JKAP,IPAN).EQ.3.AND.
     &       NODES(L,ISORT,IKAP,IPAN).EQ.
     &       NODES(L,ISORT,JKAP,IPAN)
        IF(CASE)LNY(L,ISORT,JKAP,IPAN)=ICLS
        ENDDO
        ENDIF
        ENDDO
        NCLS(L,ISORT,IPAN)=ICLS
        ENDDO
        ENDDO
        ENDDO
C CHECK WHETHER THE NUMBER OF VALENCE BANDS IS CORRECT
        ZVAL=0.D0
        DO ISORT=1,NSORT              !!! define total valence charge
        ZVAL=ZVAL+(Z(ISORT)-ZCORE(ISORT))*NHSORT(ISORT)
        ENDDO
        DO IPAN=2,NPAN                !!! define semicore charge
        ZVAL=ZVAL-2.D0*NBNDT(IPAN)
        ENDDO
        IF(NFF.GT.-1)THEN ! check it
        NBNDF(1)=NFF+NEF
        NBNDE(1)=NFF+1
        NBNDC(1)=NBNDF(1)-NBNDE(1)+1
        IF(2.D0*NBNDF(1).LT.ZVAL)CALL ERRMSG('READINI',12,' ','W')
        IF(2.D0*NBNDF(1).LT.ZVAL)NFF=-1
        ENDIF
        IF(NFF.EQ.-1)THEN ! set automatically
        IF(MOD(ZVAL,2.D0).LT.1.D-10)NVL=ZVAL/2.D0
        IF(MOD(ZVAL,2.D0).GE.1.D-10)NVL=ZVAL/2.D0+1
        IF(MOD(DBLE(NEF),2.D0).LT.1.D-10)NFF=NVL-NEF/2
        IF(MOD(DBLE(NEF),2.D0).GT.1.D-10)NFF=NVL-NEF/2-1
        IF(NFF.LT.0)NFF=0
        NBNDF(1)=NFF+NEF
        NBNDE(1)=NFF+1
        NBNDC(1)=NBNDF(1)-NBNDE(1)+1
        ENDIF
	DO IPAN=1,NPAN
	DO IKAP=1,NKAP(IPAN)
	EKAP(IKAP,IPAN)=EKAP(IKAP,IPAN)*PAR0**2/PAR**2
	EK(IKAP,IPAN)=EKAP(IKAP,IPAN)*PAR*PAR
	ENDDO
	ENDDO
C  SET BZ-SHIFT FOR METALLIC CASE
	DO IPAN=1,NPAN
	DO I=1,3
	SH(I,IPAN)=0.D0 
	ENDDO
	ENDDO
	IF(NBNDF(1)-NBNDE(1)+1.NE.0.AND.ICBND.EQ.0)THEN
	SH(1,1)=0.D0!1.D-07
	SH(2,1)=0.D0!2.D-07
	SH(3,1)=0.D0!3.D-07
	ENDIF
1000    FORMAT(A)
1001    FORMAT(/A)
	END
