	SUBROUTINE QVECTOR
************************************************************
*  Sets perturbation vector and mixing values.             *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NITER(-1:1,NPAT),NQDIV(3),NDIV(3)
	DIMENSION EPS(-1:1,NPAT),TAU(3,NPAT),ORTH(2:3)
     &   ,A(3,3),G(3,3),QPNT(3),QPNT0(3),AK(3,3),RK(3,3)
        CHARACTER*60 HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
	CHARACTER TEXQ*10,TXTEL(NSORTMAX)*10,TXTSP(2)*2,UN(100)*2
     &   ,TEXM*60,TASK*10,RS*10,TNUC(-1:1,NPAT)*10,TPTB(NENVMAX)*10
	LOGICAL EXIST,LNUC(-1:1,NPAT)
C Controls:
        COMMON /CONTROL/ LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /SPIN/    NSPIN                               !!! from init
	COMMON /PLZCOM/  NPLZ,LPLZ,IPLZ                      !!! from init
C Inputs:
	COMMON /LATTICE/ A,G,AK,RK                           !!! from init
	COMMON /BASIS/   TAU                                 !!! from init
	COMMON /QMESH/   NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from init
        COMMON /PHNCOM/  ITERMAX,NITER,EPS                   !!! from init
        COMMON /INTTR/   NDIV                                !!! from init
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                     !!! from init
C Mixings:
        COMMON /INP2/    HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
        COMMON /TXTEL/   TXTEL,TXTSP,TEXQ,TEXM,TASK          !!! from init
	COMMON /UNIT/    IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
C--------------------------------------------
C *** READ Q-VECTOR FROM PNTFILE ************
C--------------------------------------------
	OPEN(UNIT=1,FILE=PNTFILE,STATUS='OLD',FORM='FORMATTED')
	READ(1,*)NQPNT,NQDIV(1),NQDIV(2),NQDIV(3)
	DO ISKIP=1,5
	READ(1,*)
	ENDDO
	DO IPNT=1,NQPNT
	READ(1,*)IQPNT,(QPNT(I),I=1,3)
	IF(IQPNT.EQ.NUMQ)EXIT
	ENDDO
        CLOSE(1)
C ACCOUNT FOR ORTHOROMBICITY PARAMETERS
	QPNT(1)=QPNT(1)
	QPNT(2)=QPNT(2)/ORTH(2)
	QPNT(3)=QPNT(3)/ORTH(3)
	END
