	SUBROUTINE STRMSH
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX)
	CHARACTER*60 KOVFILE,FTRFILE,CONFILE,SYS*1
	LOGICAL FIRST
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/A(3,3)                              !!! from init
	COMMON /BASIS/  TAU(3,NPAT)                         !!! from init
        COMMON /OUT1/   ICCON,ICFTR,ICKOV                   !!! from readstr
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE             !!! from readstr
	COMMON /GROUPOUT/NGROUP                             !!! from group
        COMMON /ORBS/   NORBS                               !!! from init
        COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdata
	DATA PI/3.141592653589793D0/,EPS/1.D-05/
C  INITIATION
	LMMT=0
	LMMB=0
	LMMV=0
	DO 10 IATOM=1,NATOM
	LMMT=MAX(LMMT,ILST(IS(IATOM)))   !!! maximum lmaxt for all atoms
	LMMB=MAX(LMMB,ILSB(IS(IATOM)))   !!! maximum lmaxb for all atoms
	LMMV=MAX(LMMV,ILSV(IS(IATOM)))   !!! maximum lmaxv for all atoms
  10    CONTINUE
	LMMC=MAX(LMMT+1,LMMV+1)
C  CALCULATE TRANSFORMATION MATRICES
        IF(ICKOV.EQ.1)SYS='C'
        IF(ICKOV.EQ.2)SYS='H'
        IF(ICKOV.EQ.3)SYS='A'
        CALL WIGMAT(MAX(LMMT+1,LMMV),SYS,KOVFILE)
        CALL GROUPS(A,TAU,IS,MAX(LMMT+1,LMMV),NATOM,NSPIN,NORBS,EPS,1)
        WRITE(IUN,1010)NGROUP
	CALL KELITAB              !!! calculate Keli table
1010    FORMAT(1X,I4,' elements discovered')
	END
