	PROGRAM GMAIN
*************************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NDIV(3),NDIC(3),IGS(0:50,0:50,0:50)
     &	 ,IGQ(0:50,0:50,0:50),IPQ(0:50,0:50,0:50),KCUT(3,4,6)
     &   ,IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,ISG(NOPRMAX,NOPRMAX),MSYMPN(NOPRMAX,KMAX)
     &   ,KSYMPN(NOPRMAX,KMAX),NQDIV(3)
	DIMENSION WGT(KMAX),PNT(3,KMAX),AK(3,3),RK(3,3)
     &   ,WVEL(NBNDMAX,NBNDMAX,3),WEPI(NBNDMAX,NBNDMAX)
     &   ,A(3,3),TAU(3,NPAT),G(3,3),QPNT(3)
        COMPLEX*16 DELH(NBNDMAX,NBNDMAX,-1:1,NPAT),TR(-1:1,3)
     &   ,DELHR(NBNDMAX,NBNDMAX,3,NPAT),ALAMB,ALAMK(KMAX,NOPRMAX)
     &   ,DYNINV(3,NPAT,3,NPAT,3*NPAT)
        CHARACTER*60 INPFILE,CONFILE,SRFFILE,KOVFILE,BNDFILE,WFFILE
     &   ,SCFFILE,STRFILE,SCRFILE(100),DSFFILE,DROFILE,PHNFILE,TMPFILE
     &   ,DVFILE,OUTFILE,WGTFILE,PWRFILE,PWSFILE,PLZFILE
        CHARACTER SYS*1,TEXQ*10,TXTEL(NSORTMAX)*10,TXTSP(2)*2
	COMMON /LATTICE/A,G,AK,RK                           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSW,NATOM       !!! from init
        COMMON /QMESH/  NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /INTTR/  NDIV                                !!! from init
	COMMON /GROUPOUT/NGROUP
	COMMON /MESH/   NPNT,PNT,WGT                        !!! from bzmesh
	COMMON /WMESH/  KCUT,IPQ,IGQ                        !!! from bzmesh
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG,KSYMPN,MSYMPN,IGS      !!! from symmsh
        COMMON /OUT0EL/ SCRFILE,SCFFILE,STRFILE             !!! from init
        COMMON /OUT1EL/ ICON,ISRF,IKOV,IBND,IWF             !!! from init
        COMMON /OUT2EL/ CONFILE,SRFFILE,KOVFILE,BNDFILE,WFFILE! from init
        COMMON /OUT1PH/ IDSF,IDRO,IPHN,ITMP,IDV,IOUT,IWTH   !!! from init
        COMMON /OUT2PH/ DSFFILE,DROFILE,PHNFILE,TMPFILE,DVFILE
     &                 ,OUTFILE,WGTFILE                     !!! from init
        COMMON /OUT3PH/ PWRFILE,PWSFILE                     !!! from init
        COMMON /OUT4PH/ PLZFILE                             !!! from init
	COMMON /UNIT/   IUN
        COMMON /TXTEL/  TXTEL,TXTSP,TEXQ
        COMMON /WORD/   NVAL                   
	DATA EPS/1.D-05/
        DATA TR/(+0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,(-0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 1.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)/
	IUN=6
        PRINT1010
        READ(5,1000)INPFILE
C  SET Q-VECTOR NUMBER
        PRINT1015
        READ(5,1000)TEXQ
        NQ=INDEX(TEXQ,' ')
        IF(NQ.NE.1)READ(TEXQ,*)NUMQ
        IF(NQ.EQ.1)NUMQ=1
 	PRINT*,'STORE INUC #?'
 	READ(5,*)INUC0
1000    FORMAT(A)
1010    FORMAT(1X,'INPFILE? ',$)
1015    FORMAT(1X,'Q-POINT? ',$)
        CALL READINP(INPFILE)
        CALL READSTR
	CALL QVECTOR
C  READ DYNAMICAL MATRIX
        OPEN(UNIT=1,FILE='cacuo2.dyn',STATUS='OLD',FORM='FORMATTED')
        READ(1,*)NATOM,(IS(IATOM),IATOM=1,NATOM),NPNT
	NSORT=3 
        DO 10 IPNT=1,NPNT
        READ(1,*)(PNT(I,IPNT),I=1,3)
        DO 10 IBND=1,3*NATOM
        DO 10 IATOM1=1,NATOM
        DO 10 IATOM=1,NATOM
        DO 10 IA1=1,3
        IF(IPNT.EQ.NUMQ)
     &  READ(1,*)(DYNINV(IA1,IATOM1,IA,IATOM,IBND),IA=1,3)
        IF(IPNT.NE.NUMQ)
     &  READ(1,*)
  10    CONTINUE
C  CALUCLATE POINT GROUP
        IF(IKOV.EQ.1)SYS='C'
        IF(IKOV.EQ.2)SYS='H'
        IF(IKOV.EQ.3)SYS='A'
        CALL WIGMAT(2,SYS,KOVFILE)
        CALL GROUPS(A,TAU,IS,2,NATOM,1,1,EPS,2)
        WRITE(IUN,1020)NGROUP
C  CALCULATE TETRAHEDRON MESH
	CALL SBZMESH(NDIV)
C  SET Q-VECTOR
	CALL QVECTOR
        WRITE(IUN,1030)NPNT
C  UNDERSTAND SYMMETRY
	CALL DELMSH(1)
C  READ MATRIX ELEMENTS
        INQUIRE(FILE=WGTFILE,RECL=NRECL)
CWRONG  IF(WRONG)THEN                !!! wrong compiler option
        NRECL=NVAL
        OPEN(UNIT=39,FILE=WGTFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
        READ(39,REC=1)NRECL
        CLOSE(39)
CWRONG  ENDIF
        OPEN(UNIT=39,FILE=WGTFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
        READ(39,REC=1)NRECL,NDIV(1),NDIV(2),NDIV(3),NPNT,
     &  NBNDF(1),NBNDE(1),NBNDT(1),IMRE
C  SET DIVISIONS ALONG X,Y,Z
        N1=NDIV(1)
        N2=NDIV(2)
        N3=NDIV(3)
C  DO OVER WHOLE BRILLOUIN ZONE REPRESENTED BY MICROCELLS AND
C  INTEGRATE OVER THE TETRAHEDRA
        OT=1.D0/DBLE(N1*N2*N3)/6.D0
        VOLIBZ=1.D0
C  TRANSFORM TO X,Y,Z - COORDINATES
        DO 330 J3=0,N3                      !!! over cells along G3
        DO 320 J2=0,N2                      !!! over cells along G2
        DO 310 J1=0,N1                      !!! over cells along G1
	I1=J1
	I2=J2
	I3=J3
	IF(J1.EQ.N1)I1=0
	IF(J2.EQ.N2)I2=0
	IF(J3.EQ.N3)I3=0
C  READ WEIGHTS FOR THE POINTS
        IPNT=IPQ(I1,I2,I3)
        ISGQ=IGS(I1,I2,I3)
        IREC=1+IPNT+NPNT*(ISGQ-1)
        READ(39,REC=IREC)
     &  ((WEPI(IBND,IBND1  ),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,1),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,2),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,3),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((((DELH(IBND,IBND1,MY,INUC),IBND=1,NBNDF(1)-NBNDE(1)+1),
     &  IBND1=1,NBNDF(1)-NBNDE(1)+1),MY=-1,1),INUC=1,NATOM)
C  TRANSFORM TO X,Y,Z - COORDINATES
	DO 140 IBND1=1,NBNDF(1)-NBNDE(1)+1
	DO 130 IBND =1,NBNDF(1)-NBNDE(1)+1
	DO 120 INUC=1,NATOM
        DO 110 I=1,3
        DELHR(IBND1,IBND,I,INUC)=(0.D0,0.D0)
        DO 100 MY=-1,1                           !!! over -1,0,1
        DELHR(IBND1,IBND,I,INUC)=DELHR(IBND1,IBND,I,INUC)+
     &  DELH(IBND1,IBND,MY,INUC)*TR(MY,I)
 100    CONTINUE                                 !!! over -1,0,1
 110	CONTINUE
 120	CONTINUE
 130	CONTINUE
 140	CONTINUE
C  STORE MATRIX ELEMENTS
 	WRITE(99,1040)J1,J2,J3,
     &  (DREAL(DCONJG(DELHR(1,1,I,INUC0))*DELHR(1,1,I,INUC0)),I=1,3)
C  MAKE CONVOLUTION WITH THE PHONON SPECTRUM
	ALAMB=(0.D0,0.D0)
        DO 250 IBND=1,3*NATOM
        DO 240 IATOM1=1,NATOM
        DO 230 IA1=1,3
        DO 220 IATOM=1,NATOM
        DO 210 IA=1,3
        ALAMB=ALAMB+DYNINV(IA1,IATOM1,IA,IATOM,IBND)*
     &	DCONJG(DELHR(1,1,IA1,IATOM1))*DELHR(1,1,IA,IATOM)
 210    CONTINUE
 220    CONTINUE
 230    CONTINUE
 240    CONTINUE
 250	CONTINUE
	ALAMK(IPNT,ISGQ)=ALAMB
C	WRITE(99,1040)J1,J2,J3,ALAMB
 310    CONTINUE                             !!! over cells along G1
 320    CONTINUE                             !!! over cells along G2
 330    CONTINUE                             !!! over cells along G3
	CLOSE(99)
C  INTEGRATE OVER BRILLOUIN ZONE
	ALAMB=(0.D0,0.D0)
	ALAMT=(0.D0,0.D0)
        DO 2001 ISGQ=1,NSGQ
        DO 1001 IPNT=1,NPNT
        IF(KSYMPN(ISGQ,IPNT).LT.0)GOTO1001
        IREC=1+IPNT+NPNT*(ISGQ-1)
C  READ EPI.MATRIX ELEMENTS
        READ(39,REC=IREC)
     &  ((WEPI(IBND,IBND1  ),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,1),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,2),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,3),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((((DELH(IBND,IBND1,MY,INUC),IBND=1,NBNDF(1)-NBNDE(1)+1),
     &  IBND1=1,NBNDF(1)-NBNDE(1)+1),MY=-1,1),INUC=1,NATOM)
	ALAMB=ALAMB+ALAMK(IPNT,ISGQ)*WEPI(1,1)
	ALAMT=ALAMT+ALAMK(IPNT,ISGQ)*(WVEL(1,1,1)+WVEL(1,1,2)-
     &  2.D0*WVEL(1,1,3))
1001	CONTINUE
2001	CONTINUE
	DOS=31.6868
	AVL=2.372
	print*,alamb/DOS
	print*,alamt/2.D0/AVL
1020    FORMAT(1X,I4,' elements found')
1030    FORMAT(1X,I4,' k-points generated')
1040	FORMAT(1X,I2,1X,I2,1X,I2,2X,3(G12.5,1X))
	END





        SUBROUTINE READINP(INPFILE)
************************************************************
*  <READINP> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER NSHE(NSORTMAX),NPOL(0:NSORTMAX),NQDIV(3),NDIV(3)
     &   ,IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &   ,NDIW(3)
        DIMENSION Z(NSORTMAX),ZCORE(NSORTMAX),SROU(NSORTMAX)
     &   ,QPNT(3),WVEL(NBNDMAX,NBNDMAX,3),WEPI(NBNDMAX,NBNDMAX)
        CHARACTER*60 INPFILE,CONFILE,SRFFILE,KOVFILE,BNDFILE,WFFILE
     &   ,SCFFILE,STRFILE,SCRFILE(100),DSFFILE,DROFILE,PHNFILE,TMPFILE
     &   ,DVFILE,OUTFILE,WGTFILE,PWRFILE,PWSFILE,PLZFILE,PNTFILE
        CHARACTER SYS*1,TEXQ*10,TXTEL(NSORTMAX)*10,TXTSP(2)*2,UN(100)*2
	LOGICAL EXIST 
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSW,NATOM
        COMMON /QMESH/   NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from init
        COMMON /POTCOM/  SWZ,SMT(NSORTMAX)
	COMMON /KAPPAR/  NPAN                                !!! from init
        COMMON /LATPAR/  PAR
        COMMON /INTMESH/ NSHE,NPOL,SROU
        COMMON /OUT0EL/  SCRFILE,SCFFILE,STRFILE,PNTFILE     !!! from init
	COMMON /OUT1EL/  ICON,ISRF,IKOV,IBND,IWF             !!! from init
        COMMON /OUT2EL/  CONFILE,SRFFILE,KOVFILE,BNDFILE,WFFILE! from init
        COMMON /OUT1PH/  IDSF,IDRO,IPHN,ITMP,IDV,IOUT,IWTH   !!! from init
        COMMON /OUT2PH/  DSFFILE,DROFILE,PHNFILE,TMPFILE,DVFILE
     &                  ,OUTFILE,WGTFILE                     !!! from init
        COMMON /OUT3PH/  PWRFILE,PWSFILE                     !!! from init
        COMMON /OUT4PH/  PLZFILE                             !!! from init
        COMMON /INTTR/   NDIV,NDIW                           !!! from init
        COMMON /TXTEL/   TXTEL,TXTSP,TEXQ
        DATA PI/3.141592653589793D0/
        DATA UN/'01','02','03','04','05','06','07','08','09','10'
     &         ,'11','12','13','14','15','16','17','18','19','20'
     &         ,'21','22','23','24','25','26','27','28','29','30'
     &         ,'31','32','33','34','35','36','37','38','39','40'
     &         ,'41','42','43','44','45','46','47','48','49','50'
     &         ,'51','52','53','54','55','56','57','58','59','60'
     &         ,'61','62','63','64','65','66','67','68','69','70'
     &         ,'71','72','73','74','75','76','77','78','79','80'
     &         ,'81','82','83','84','85','86','87','88','89','90'
     &         ,'91','92','93','94','95','96','97','98','99','00'/
	NPAN=1
C
        OPEN(1,FILE=INPFILE,STATUS='OLD')
C
	DO 20 I=1,11
	READ(1,*)
  20	CONTINUE
C
        READ(1,*)NATOM,NSORT,NSPIN
        READ(1,*)PAR
        READ(1,*)(IS(I),I=1,NATOM)
        READ(1,*)NKAP
C
        DO 60 ISORT=1,NSORT
        READ(1,1000)TXTEL(ISORT)
        READ(1,*)Z(ISORT),ZCORE(ISORT)
        READ(1,*)
        READ(1,*)
C
	DO 30 I=1,7
	READ(1,*)
  30	CONTINUE

        DO 40 IKAP=1,NKAP
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
  40    CONTINUE
        READ(1,*)
        READ(1,*)NC
        DO 50 IC=1,NC
        READ(1,*)
  50    CONTINUE
  60    CONTINUE
C
        READ(1,*)
        READ(1,*)ISCF,SCFFILE      !!! scf-density
        READ(1,*)ISTR,STRFILE      !!! structure information
        READ(1,*)IPNT,PNTFILE      !!! q-point list
        READ(1,*)ICON,CONFILE      !!! structure constants
        READ(1,*)ISRF,SRFFILE      !!! surface constants
        READ(1,*)IBND,BNDFILE      !!! band structure and
        READ(1,*)IWF ,WF FILE      !!! wave functions
C   ****** INPUT-OUTPUT FILES FOR "PHONONS" *******
        READ(1,*)
        READ(1,*)IDSF,DSFFILE      !!! change in srf.constants
        READ(1,*)IWTH,WGTFILE      !!! tetrahedron weights
        READ(1,*)IPHN,PHNFILE      !!! phonon spectrum
        READ(1,*)ISCR,SCRFILE(1)   !!! scratch storage
        READ(1,*)IPWR,PWRFILE      !!! output for PHNPLW-PACKAGE
        READ(1,*)IDV ,DV FILE      !!! induced potential
        READ(1,*)IPLZ,PLZFILE      !!! polarizability function
        READ(1,*)IDRO,DROFILE      !!! change in the density
        READ(1,*)IOUT,OUTFILE      !!! current output
C
        READ(1,*)
        READ(1,*)NFF,NEF
        READ(1,*)(NDIV(I),I=1,3)
        READ(1,*)(NDIW(I),I=1,3)
C 
        NQ=INDEX(TEXQ,' ')
        IF(NQ.LE.1)NQ=2
        NA=INDEX(WGTFILE,' ')
        WGTFILE=WGTFILE(:NA-1)//TEXQ(:NQ-1)
        INQUIRE(FILE=WGTFILE,EXIST=EXIST)
	IF(.NOT.EXIST)STOP'WGTFILE MUST EXIST'
        CLOSE(1)
1000    FORMAT(A60)
        END


        SUBROUTINE READSTR
************************************************************
*  <READSTR> reads crystalline structure and IBZ data      *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        CHARACTER*60 STRFILE,KOVFILE,CONFILE,SRFFILE,SCRFILE(100)
     &    ,SCFFILE
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &    ,NDIV(3),NDIW(3)
        DIMENSION RBASR(3,3),TAUR(3,NPAT),BASR(3),BBASR(3,3),ORTH(2:3)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,SH(3),AK(3,3),RK(3,3),AW(3,3),RW(3,3)
     &    ,RSTN(3,3),TAU0(3,NPAT),TAU0R(3,NPAT)
        CHARACTER TEXT*64,TEXTS*64,STRING(80)*1,SYS*1,TXT*72
        COMMON /LATTICE/RBAS,GBAS,AK,RK,AW,RW           !!! from init
        COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from init
        COMMON /BASIS/  TAU                             !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSW,NATOM   !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from init
        COMMON /OUT0EL/ SCRFILE,SCFFILE,STRFILE         !!! from init
        COMMON /OUT1EL/ ICON,ISRF,IKOV                  !!! from init
        COMMON /OUT2EL/ CONFILE,SRFFILE,KOVFILE         !!! from init
        COMMON /INTTR/  NDIV,NDIW,SH                    !!! from init
        COMMON /STRINP/ NVECMX,ALPHA                    !!! from init
        COMMON /SRFINP/ NDIV1,NDIV2                     !!! from init
        COMMON /TEXT/   TEXT,TEXTS                      !!! from init
        COMMON /UNIT/   IUN                             !!! from init
        DATA PI/3.141592653589793D0/
C--------------------------------------------
C***** INPUT FILE 3 FOR NMT-PACK ************
C--------------------------------------------
        OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD')
        READ(1,1000)TEXTS
C  **** MAIN PARAMETERS *********************
C  NATOM - number of atoms in unit-cell
C  ORTH  - ortorhombicity, i.e. b/a, c/a
C  IBAS  - if 1 then Cartesian, else in RBAS
C  IBZ   - if 1 then from RBAS, else input
C  ICALC - if 1 using the calculator
C  ISTRAIN - if 1 plane waves follow the distortions
C  NDIV1 - generation of polyhedra parameter
C  NDIV2 - polyhedron surface mesh parameter
C  NVECMX - number of structure vectors
C  ALPHA - Evald's splitting parameter
        READ(1,1001)TXT
        READ(1,*) NATOM0,ORTH
        READ(1,*) IBAS,IBZ,ICALC,ISTRAIN
        READ(1,*) NDIV1,NDIV2
        READ(1,*) NVECMX,ALPHA
        IF(NATOM0.NE.NATOM)STOP'<READSTR>: # OF ATOMS MISMATCHES
     &  IN STRFILE, CHECK IT'
C  **** PRIMITIVE TRANSLATIONS **************
C  RBAS(1:3,IVEC) - x,y,z components of translations
        READ(1,1000)TXT
        DO 10 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(RBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,RBASR(1,IVEC),3)
        ENDIF
  10    CONTINUE
C  **** BASIS ATOMS IN ORIGINAL CELL ****************
C  TAU0  - positions of atoms in original cell
        READ(1,1000)TXT
        DO 15 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAU0R(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAU0R(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAU0R(1,IATOM)=BASR(1)*RBASR(1,1)
     &                +BASR(2)*RBASR(1,2)
     &                +BASR(3)*RBASR(1,3)
        TAU0R(2,IATOM)=BASR(1)*RBASR(2,1)
     &                +BASR(2)*RBASR(2,2)
     &                +BASR(3)*RBASR(2,3)
        TAU0R(3,IATOM)=BASR(1)*RBASR(3,1)
     &                +BASR(2)*RBASR(3,2)
     &                +BASR(3)*RBASR(3,3)
        ENDIF
  15    CONTINUE
C  **** BASIS ATOMS IN DISTORTED CELL ****************
C  TAU  - actual positions of atoms
        READ(1,1000)TXT
        DO 20 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAUR(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAUR(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAUR(1,IATOM)=BASR(1)*RBASR(1,1)
     &               +BASR(2)*RBASR(1,2)
     &               +BASR(3)*RBASR(1,3)
        TAUR(2,IATOM)=BASR(1)*RBASR(2,1)
     &               +BASR(2)*RBASR(2,2)
     &               +BASR(3)*RBASR(2,3)
        TAUR(3,IATOM)=BASR(1)*RBASR(3,1)
     &               +BASR(2)*RBASR(3,2)
     &               +BASR(3)*RBASR(3,3)
        ENDIF
  20    CONTINUE
C  **** STRAIN MATRIX ***********************                      _
C  STRAIN(1..3,1..3) - matrix applied to translations and basis R'=S*R
C  Its diagonal components in case no strain are just 1,1,1
        READ(1,1000)TXT
        DO 30 I=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(STRAIN(I,J,1),J=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        STRAIN(I,1,1)=BASR(1)
        STRAIN(I,2,1)=BASR(2)
        STRAIN(I,3,1)=BASR(3)
        ENDIF
  30    CONTINUE
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
        CALL CROSS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
        CALL CROSS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
        CALL CROSS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
        W=STRAIN(1,1,1)*RSTN(1,1)
     &   +STRAIN(2,1,1)*RSTN(2,1)
     &   +STRAIN(3,1,1)*RSTN(3,1)
        IF(ABS(W).LE.1.D-10)STOP'<READSTR>:: WRONG STRAIN, DET=0'
        IF(ABS(W-1.D0).GE.1.D-10)
     &  PRINT*,'<READSTR>:: STRAINS NOT DEBUGGED!'
        DO 40 I=1,3
        STRAIN(1,I,2)=RSTN(I,1)/W
        STRAIN(2,I,2)=RSTN(I,2)/W
        STRAIN(3,I,2)=RSTN(I,3)/W
  40    CONTINUE
C  **** POINT GROUP DESCRIPTION *************
C  SYS - C(cubic) or H(hexogonal) system of rotations
C      - A(arbitrary) system can be also specified.
C        Group operations must be listed in KOVFILE,
C        see WIGMAT subroutine for more details.
        READ(1,1000)TXT
        READ(1,*)SYS
        IF(SYS.EQ.'C')IKOV=1
        IF(SYS.EQ.'H')IKOV=2
        IF(SYS.EQ.'A')IKOV=3
        IF(IKOV.EQ.3)THEN
        BACKSPACE(1)
        READ(1,*)SYS,KOVFILE
        ENDIF
C  ****  BRILLOUIN ZONE **********
C  BBAS - three primitive translations (possibly reciprocal lattice vectors)
        READ(1,1000)TXT
        DO 50 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(BBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BBASR(1,IVEC),3)
        ENDIF
  50    CONTINUE
        CLOSE(1)
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
        DO 90 I=2,3
        DO 70 IVEC=1,3
        RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
        BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
  70    CONTINUE
        DO 80 IATOM=1,NATOM
        TAU0R(I,IATOM)=TAU0R(I,IATOM)*ORTH(I)
        TAU R(I,IATOM)=TAU R(I,IATOM)*ORTH(I)
  80    CONTINUE
  90    CONTINUE
C  APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
        DO 150 IVEC=1,3
        DO 150 I=1,3
        RBAS(I,IVEC)=0.D0
        DO 140 J=1,3
        RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC)
 140    CONTINUE
 150    CONTINUE
C  APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
        DO 170 IATOM=1,NATOM
        DO 170 I=1,3
        TAU (I,IATOM)=0.D0
        TAU0(I,IATOM)=0.D0
        DO 160 J=1,3
        TAU (I,IATOM)=TAU (I,IATOM)+STRAIN(I,J,1)*TAU R(J,IATOM)
        TAU0(I,IATOM)=TAU0(I,IATOM)+STRAIN(I,J,1)*TAU0R(J,IATOM)
 160    CONTINUE
 170    CONTINUE
C  APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
        DO 190 IVEC=1,3
        DO 190 I=1,3
        BBAS(I,IVEC)=0.D0
        DO 180 J=1,3
        BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
 180    CONTINUE
 190    CONTINUE
C  SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
        CALL CROSS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
        CALL CROSS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
        CALL CROSS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
        W=RBAS(1,1)*GBAS(1,1)
     &   +RBAS(2,1)*GBAS(2,1)
     &   +RBAS(3,1)*GBAS(3,1)
        DO 230 I=1,3
        GBAS(I,1)=GBAS(I,1)/W
        GBAS(I,2)=GBAS(I,2)/W
        GBAS(I,3)=GBAS(I,3)/W
 230    CONTINUE
        OMEGAC=ABS(W)*PAR**3
C  SET BRILLOUIN ZONE TO GBAS IF REQUIRED
        IF(IBZ.EQ.1)THEN
        DO 240 I=1,3
        BBAS(I,1)=GBAS(I,1)
        BBAS(I,2)=GBAS(I,2)
        BBAS(I,3)=GBAS(I,3)
 240    CONTINUE
        ENDIF
C  SET PRIMITIVE TRANSLATIONS FOR BZ AND PRIMITIVE CELL
        DO 250 I=1,3
        AK(I,1)=BBAS(I,1)/NDIV(1)
        AK(I,2)=BBAS(I,2)/NDIV(2)
        AK(I,3)=BBAS(I,3)/NDIV(3)
        AW(I,1)=BBAS(I,1)/NDIW(1)
        AW(I,2)=BBAS(I,2)/NDIW(2)
        AW(I,3)=BBAS(I,3)/NDIW(3)
 250    CONTINUE
C  SET TRANSLATIONS WHICH ARE RECIPROCAL TO AK
        CALL CROSS(RK(1,1),AK(1,2),AK(1,3))
        CALL CROSS(RK(1,2),AK(1,3),AK(1,1))
        CALL CROSS(RK(1,3),AK(1,1),AK(1,2))
        W=AK(1,1)*RK(1,1)+AK(2,1)*RK(2,1)+AK(3,1)*RK(3,1)
        DO 260 I=1,3
        RK(I,1)=RK(I,1)/W
        RK(I,2)=RK(I,2)/W
        RK(I,3)=RK(I,3)/W
 260    CONTINUE
C  SET TRANSLATIONS WHICH ARE RECIPROCAL TO AW
        CALL CROSS(RW(1,1),AW(1,2),AW(1,3))
        CALL CROSS(RW(1,2),AW(1,3),AW(1,1))
        CALL CROSS(RW(1,3),AW(1,1),AW(1,2))
        W=AW(1,1)*RW(1,1)+AW(2,1)*RW(2,1)+AW(3,1)*RW(3,1)
        DO 270 I=1,3
        RW(I,1)=RW(I,1)/W
        RW(I,2)=RW(I,2)/W
        RW(I,3)=RW(I,3)/W
 270    CONTINUE
1000    FORMAT(A)
1001    FORMAT(/A)
1010    FORMAT(2(1X,A1))
1020    FORMAT(80A1)
        END
