	SUBROUTINE QVECTOR
************************************************************
*  Sets perturbation vector and mixing values.             *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &   ,NITER(-1:1,NPAT),KEY(-1:1,NPAT),NQDIV(3),NDIV(3)
	DIMENSION EPS(-1:1,NPAT),ADMIX(-1:1,NPAT)
     &   ,ADMIN(-1:1,NPAT),ADMAX(-1:1,NPAT),TAU(3,NPAT)
     &   ,ORTH(2:3),A(3,3),G(3,3),QPNT(3),AK(3,3),RK(3,3)
        CHARACTER*60 SCFFILE,STRFILE,SCRFILE(100),PNTFILE
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSW,NATOM       !!! from init
	COMMON /LATTICE/ A,G,AK,RK                           !!! from init
	COMMON /BASIS/   TAU                                 !!! from init
	COMMON /QMESH/   NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from init
	COMMON /PHNCOM/  ITERMAX,NITER,ADMIX,ADMIN,ADMAX,KEY,EPS
        COMMON /INTTR/   NDIV                                !!! from init
	COMMON /LATPAR/  PAR,ORTH,OMEGAC                     !!! from init
        COMMON /OUT0EL/  SCRFILE,SCFFILE,STRFILE,PNTFILE     !!! from init
	COMMON /UNIT/    IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
C  READ Q-VECTOR
	OPEN(UNIT=1,FILE=PNTFILE,STATUS='OLD',FORM='FORMATTED')
	READ(1,*)NQPNT,NQDIV(1),NQDIV(2),NQDIV(3)
	DO 10 ISKIP=1,5
	READ(1,*)
  10	CONTINUE
	DO 20 IPNT=1,NQPNT
	READ(1,*)IQPNT,(QPNT(I),I=1,3)
	IF(IQPNT.EQ.NUMQ)GOTO30
  20	CONTINUE
  30	CLOSE(1)
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
	QPNT(1)=QPNT(1)
	QPNT(2)=QPNT(2)/ORTH(2)
	QPNT(3)=QPNT(3)/ORTH(3)
C  SET MIXING PARAMETERS
	DO 50 INUC=1,NATOM
	DO 40 MY=-1,1
	AMAX=ADMAX(MY,INUC)
	ADMAX(MY,INUC)=AMAX
	ADMIN(MY,INUC)=ADMAX(MY,INUC)/3.D0
	ADMIX(MY,INUC)=(ADMAX(MY,INUC)+ADMIN(MY,INUC))/2.D0
  40	CONTINUE
  50	CONTINUE
	END
