	SUBROUTINE OUTPUT(TEXT,IQPNT)
******************************************************
*   Output from the phonon program.                  *
*   Written by S.Yu.Savrasov                         *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX)
	COMPLEX*16 DYNMAT(3,NPAT,3,NPAT,4),DPOL(3,NPAT,3*NPAT)
	DIMENSION SROU(NSORTMAX),H(NSORTMAX),OM(3*NPAT)
     &   ,AMASS(NSORTMAX),QPNT(3),SMT(NSORTMAX),ORTH(2:3)
	CHARACTER*60 DSFFILE,PHNFILE,TMPFILE,OUTFILE,WGTFILE
     &   ,SCRFILE(100)
        CHARACTER*60 SCNFILE(-1:1,NPAT,100),DROFILE,DVFILE
     &   ,DPSFILE,DPVFILE
	CHARACTER TXTEL(NSORTMAX)*10,TEXT*(*),EQ(64),TEXCH(0:30)*40
     &    ,TRELATIV(0:1)*4
	LOGICAL EXIST,OPEN
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /MASS/   AMASS                               !!! from init
	COMMON /QMESH/  NQPNT,QPNT                          !!! from init
	COMMON /LATPAR/ PAR,ORTH                            !!! from init
	COMMON /DYNMAT/ DYNMAT,OM,DPOL,IFT                  !!! from dynmat
        COMMON /OUT0EL/ SCRFILE                             !!! from init
	COMMON /OUT1EL/ ICON,ISRF,IKOV,IBND,IPSI            !!! from init   
        COMMON /OUT0PH/ SCNFILE,DROFILE,DVFILE,DPSFILE,DPVFILE! from init
	COMMON /OUT1PH/ IDSF,IDRO,IPHN,ITMP,IDV,IOUT,IWTH   !!! from init
	COMMON /OUT2PH/ DSFFILE,PHNFILE,TMPFILE,OUTFILE,WGTFILE!from init
	COMMON /TXTEL/  TXTEL                               !!! from init
C  STORE DYNAMICAL MATRIX, PHONON SPECTRUM AND POLARIZATIONS
	OPEN(3,FILE='OMG',STATUS='NEW',FORM='FORMATTED')
	WRITE(3,1109)(QPNT(I),I=1,3)
	WRITE(3,1100)
	DO 30 INUC=1,NATOM             !!! over displacements
	DO 20 JNUC=1,NATOM             !!! over displacements
	DO 10 I=1,3                    !!! over x,y,z
	WRITE(3,1101)(DYNMAT(I,INUC,J,JNUC,IFT),J=1,3)
  10    CONTINUE                       !!! over x,y,z
  20    CONTINUE                       !!! over displacements
  30    CONTINUE                       !!! over displacements
	WRITE(3,1102)
	WRITE(3,1106)(OM(IOMG),IOMG=1,3*NATOM)
	WRITE(3,1103)
	WRITE(3,1106)(OM(IOMG)*11605.0,IOMG=1,3*NATOM)  !!! Degrees K
	WRITE(3,1104)
	WRITE(3,1106)(OM(IOMG)*8065.80,IOMG=1,3*NATOM)  !!! sm**(-1)
	WRITE(3,1105)
	WRITE(3,1106)(OM(IOMG)*241.807,IOMG=1,3*NATOM)  !!! THz
	WRITE(3,1107)
	DO 50 IOMG=1,3*NATOM           !!! over phonon branches
	DO 40 IATOM=1,NATOM            !!! over atoms
	WRITE(3,1108)(DPOL(I,IATOM,IOMG),I=1,3)
  40    CONTINUE                       !!! over atoms
  50    CONTINUE                       !!! over phonon branches
	CLOSE(3)
1100    FORMAT(5X,'D Y N A M I C A L   M A T R I X (Ry/a.u**2)')
1101    FORMAT(1X,2G12.5,' | ',2G12.5,' | ',2G12.5)
1102    FORMAT(5X,'P H O N O N     S P E C T R U M (eV)')
1103    FORMAT(5X,'P H O N O N     S P E C T R U M (K)')
1104    FORMAT(5X,'P H O N O N     S P E C T R U M (sm**(-1))')
1105    FORMAT(5X,'P H O N O N     S P E C T R U M (THz)')
1106    FORMAT(1X, G12.5,' | ', G12.5,' | ', G12.5)
1107    FORMAT(5X,'P O L A R I Z A T I O N S')
1108    FORMAT(1X,2G12.5,' , ',2G12.5,' , ',2G12.5)
1109    FORMAT(5X,'Q - V E C T O R =  ( ',G12.5,' , ',
     &  G12.5,' , ',G12.5,' )')
	STOP
	END
