	PARAMETER (KMAX=200,NPAT=15)
	CHARACTER  TEXT*17,NU(100)*2,EL*20,EXT*10
	LOGICAL EXIST
	DIMENSION QPNT(3,KMAX)
	COMPLEX*16 DMAT(3,NPAT,3,NPAT,KMAX)
	DATA NU/'01','02','03','04','05','06','07','08','09','10'
     &         ,'11','12','13','14','15','16','17','18','19','20'
     &         ,'21','22','23','24','25','26','27','28','29','30'
     &         ,'31','32','33','34','35','36','37','38','39','40'
     &         ,'41','42','43','44','45','46','47','48','49','50'
     &         ,'51','52','53','54','55','56','57','58','59','60'
     &         ,'61','62','63','64','65','66','67','68','69','70'
     &         ,'71','72','73','74','75','76','77','78','79','80'
     &         ,'81','82','83','84','85','86','87','88','89','90'
     &         ,'91','92','93','94','95','96','97','98','99','00'/
	PRINT*,' Reads DYNAMICAL MATRIX from standard PHN file:'
	PRINT1
   1    FORMAT(1X,$,'Enter #  of q-points: ')
	READ(5,*)NPNT
	IF(NPNT.GT.KMAX)STOP'NPNT>KMAX, INCREASE KMAX INSIDE PROGRAM!'
	PRINT2
   2    FORMAT(1X,$,'Enter #  of atoms   : ')
	READ(5,*)NATOM
	IF(NATOM.GT.NPAT)STOP'NATOM>NPAT,INCREASE NPAT INSIDE PROGRAM!'
	PRINT3
   3    FORMAT(1X,$,'Enter filename.ext  : ')
	READ(5,4)EL
   4    FORMAT(A)
        NF=INDEX(EL,' ')
	IF(NF.EQ.0)STOP'BLANCK NAMES DO NOT ALLOWED!'
	DO 200 IF=1,NPNT
	INQUIRE(FILE=EL(:NF-1)//NU(IF),EXIST=EXIST)
	IF(.NOT.EXIST)GOTO200
	PRINT*,'PROCESSING ---> ',EL(:NF-1)//NU(IF)
	OPEN(1,FILE=EL(:NF-1)//NU(IF))
	READ(1,1020)(QPNT(I,IF),I=1,3)
1020    FORMAT(5X,21X,G12.5,3X,G12.5,3X,G12.5,3X)
        READ(1,*)
        DO INUC1=1,NATOM              !!! over nuclear shifts
        DO INUC=1,NATOM               !!! over nuclear shifts
        DO IXYZ1=1,3                  !!! over x,y,z
        READ(1,1040)(DMAT(IXYZ1,INUC1,IXYZ,INUC,IF),IXYZ=1,3)
	ENDDO
1040    FORMAT(1X,2G12.5,3X,2G12.5,3X,2G12.5)
	ENDDO                         !!! over nuclear shifts
	ENDDO                         !!! over nuclear shifts
        CLOSE(1)
 200    CONTINUE
	OPEN(1,FILE='DYN',STATUS='NEW')
	DO 400 IF=1,NPNT
	WRITE(1,1050)(QPNT(I,IF),I=1,3)
1050    FORMAT(1X,G11.4,1X,G11.4,1X,G11.4) 
        DO INUC1=1,NATOM              !!! over nuclear shifts
        DO INUC=1,NATOM               !!! over nuclear shifts
        DO IXYZ1=1,3                  !!! over x,y,z
        WRITE(1,1060)(DMAT(IXYZ1,INUC1,IXYZ,INUC,IF),IXYZ=1,3)
1060    FORMAT(1X,3('(',G11.4,',',G11.4,')',1X))
	ENDDO
	ENDDO                         !!! over nuclear shifts
	ENDDO                         !!! over nuclear shifts
 400    CONTINUE
	END
