	SUBROUTINE SYMNUC
********************************************************
*  Symmetry of the phonon modes.                       *
********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),IKOV(NOPRMAX)
     &   ,ISG(NOPRMAX,NOPRMAX),NITER(-1:1,NPAT)
     &   ,IP(NPAT,NOPRMAX),NQDIV(3)
	COMPLEX*16 U(NWIGMAX,48),SUM(NWIGMAX)
	DIMENSION QPNT(3),RDC(3,NPAT,NOPRMAX)
     &   ,USUM(-1:1,NPAT,-1:1,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10,TSUM(-1:1,NPAT,-1:1,NPAT)*1
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /PHNCOM/ ITERMAX,NITER                       !!! from init
	COMMON /QMESH/  NQPNT,QPNT,NUMQ,NQDIV,KEYQ,USUM     !!! from init
        COMMON /INVERS/ INV,IKOV                            !!! from group
        COMMON /GROUPOUT/NGROUP,U,IP,RDC                    !!! from group
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG                      !!! from symmsh
        COMMON /WORD/   NVAL                                !!! from block
	COMMON /TXTEL/  TXTEL                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
        DATA PI/3.141592653589793D0/
C  SET SUM TO ZERO
	DO INUC1=1,NATOM
	DO INUC=1,NATOM
	DO MY1=-1,1
	DO MY=-1,1
	USUM(MY1,INUC1,MY,INUC)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C CALCULATE USUM
        DO 5000 INUC=1,NATOM 
        DO 4000 MY=-1,1      
	DO 3000 INUC1=1,NATOM
        DO 2000 MY1=-1,1     
        DO 1000 IGEQ=1,NGEQ   
        IR=ISG(IGEQ,1)        
        IG=IKOV(IR)           
        INUCG=IP(INUC,IR)
        IF(INUCG.NE.INUC1)GOTO1000
        IWIGMY=3+3*(1+MY1)+MY
        IF(ABS(U(IWIGMY,IG)).LE.1.D-10)GOTO1000
	USUM(MY,INUC,MY1,INUC1)=1.D0
1000    CONTINUE
2000    CONTINUE
3000    CONTINUE
4000    CONTINUE
5000    CONTINUE
C  SET UP COUPLING 
	DO INUC1=1,NATOM
	DO INUC=1,NATOM
	DO MY1=-1,1
	DO MY=-1,1
	IF(USUM(MY,INUC,MY1,INUC1).NE.USUM(MY1,INUC1,MY,INUC))
     &  PRINT*,'ERROR IN ELEMENT ',MY,INUC,MY1,INUC1
	IF(ABS(USUM(MY1,INUC1,MY,INUC)).LE.1.D-06)
     &  TSUM(MY1,INUC1,MY,INUC)='N'
	IF(ABS(USUM(MY1,INUC1,MY,INUC)).GT.1.D-06)
     &  TSUM(MY1,INUC1,MY,INUC)='Y'
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  PRINT BLOCK
	WRITE(IUN,1010)
	DO INUC1=1,NATOM
	DO INUC=1,NATOM
	WRITE(IUN,1020)INUC1,TXTEL(IS(INUC1)),INUC,TXTEL(IS(INUC))
	WRITE(IUN,1030)
	DO MY1=-1,1
	WRITE(IUN,1040)MY1,(TSUM(MY1,INUC1,MY,INUC),MY=-1,1)
	ENDDO
	ENDDO
	ENDDO
1010	FORMAT(1X,'*** Displacements coupled by symmetry ----->>')
1020    FORMAT(1X,'Elements: atom #',I2,1X,A10,' and #',I2,1X,A10)
1030	FORMAT(1X,'mu1/mu      -1         0         1')
1040    FORMAT(3X,I2,4X,'|',4X,A1,4X,'|',4X,A1,4X,'|',4X,A1,4X,'|')
	END
